# Suggest State > The Suggest State endpoint provides predictive autocomplete and search for states and federal states, returning names, codes, and Egon IDs. The Suggest State endpoint provides predictive autocomplete and search for **states and federal states**, returning names, codes, and Egon IDs. ## Endpoint `POST https://{host}:{port}/Egon/api/suggest/state` Replace `{host}` and `{port}` with the address of your Egon instance. ## Headers | Field | Type | Required | Description | | --- | --- | --- | --- | | `token` | String | Yes | Authentication token sent in the `token` request header. | ## Request Processing options, country context, and state search query. | Field | Type | Required | Description | | --- | --- | --- | --- | | `par` | Object | Yes | Processing parameters, candidate limits, and country context | | `par.iso2` | String | No | Country code, ISO 3166-1 alpha-2. One of `iso2` or `iso3` is **required**. | | `par.iso3` | String | No | Country code, ISO 3166-1 alpha-3. One of `iso2` or `iso3` is **required**. | | `par.max_candidates` | Number | No | Maximum number of candidates to extract. Default value: `10` | | `data` | Object | Yes | Query container holding the input search string | | `data.query` | String | Yes | Query string | ### Example request ```bash curl -X POST "https://{host}:{port}/Egon/api/suggest/state" \ -H "token: YOUR_API_KEY" \ -H "Content-Type: application/json" \ -d '{"par":{"iso3":"USA"},"data":{"query":"ma"}}' ``` ## Response Matching state candidates, administrative codes, and system status. | Field | Type | Required | Description | | --- | --- | --- | --- | | `data` | Object | No | | | `data.results` | Array | No | Array of candidate matches returned by the suggestion engine | | `data.results.iso3` | String | No | Country code ISO 3166-1 alpha-3 | | `data.results.lngout` | String | No | Language code ISO 3166-1 numeric | | `data.results.country` | String | No | Country name | | `data.results.country_id` | Number | No | ID of the country | | `data.results.state` | String | No | State name | | `data.results.state_code` | String | No | State code | | `data.results.state_id` | Number | No | ID of the state | | `system` | Object | No | System error and execution status | | `system.ret_code` | Number | No | Code: 0 no blocking error, <> 0 blocking error code | | `system.des_ret_code` | String | No | Description | ### Example responses **HTTP 200: Valid response** Matching state candidates, administrative codes, and system status. ```json { "data": { "results": [ { "iso3": "USA", "lngout": "840", "country": "United States", "country_id": 84000000001, "state": "Massachusetts", "state_code": "MA", "state_id": 84000000027 }, { "iso3": "USA", "lngout": "840", "country": "United States", "country_id": 84000000001, "state": "Maine", "state_code": "ME", "state_id": 84000000029 }, { "iso3": "USA", "lngout": "840", "country": "United States", "country_id": 84000000001, "state": "Marshall Islands", "state_code": "MH", "state_id": 84000000030 }, { "iso3": "USA", "lngout": "840", "country": "United States", "country_id": 84000000001, "state": "Maryland", "state_code": "MD", "state_id": 84000000028 }, { "iso3": "USA", "lngout": "840", "country": "United States", "country_id": 84000000001, "state": "Northern Mariana Islands", "state_code": "MP", "state_id": 84000000034 } ] }, "system": { "ret_code": 0, "des_ret_code": "Ok" } } ``` **HTTP 200: Missing par** The par object is missing. ```json { "system": { "ret_code": 1, "des_ret_code": "par not found" } } ``` **HTTP 200: Missing iso2 and iso3** Iso2 or Iso3 field is missing. ```json { "system": { "ret_code": 1, "des_ret_code": "iso2 or iso3 parameter not found" } } ``` **HTTP 200: Invalid iso2** The iso2 value is not valid. ```json { "system": { "ret_code": 1, "des_ret_code": "iso2 not found" } } ``` **HTTP 200: Invalid iso3** The iso3 value is not valid. ```json { "system": { "ret_code": 1, "des_ret_code": "iso3 not found" } } ``` **HTTP 200: Missing data** The data object is missing. ```json { "system": { "ret_code": 1, "des_ret_code": "data not found" } } ``` **HTTP 200: Missing query** The query field is missing. ```json { "system": { "ret_code": 1, "des_ret_code": "query not found" } } ``` **HTTP 200: Missing token** The token request header is missing. ```json { "system": { "ret_code": 1, "des_ret_code": "token not found" } } ``` **HTTP 200: Invalid token** The token is invalid. ```json { "system": { "ret_code": 1, "des_ret_code": "token not valid" } } ```